######Video source: https://ke.biowolf.cn
######ѧ: https://www.biowolf.cn/
######΢Źںţbiowolf_cn
######䣺biowolf@foxmail.com
######΢: 18520221056

#if (!requireNamespace("BiocManager", quietly = TRUE))
#    install.packages("BiocManager")
#BiocManager::install("limma")

#install.packages("ggplot2")
#install.packages("ggpubr")
#install.packages("ggExtra")


#ð
library(limma)
library(ggplot2)
library(ggpubr)
library(ggExtra)

corFilter=0.001            #ϵĹ˱׼
pvalueFilter=1      #ԼpvalueĹ˱׼
setwd("C:\\Users\\86151\\Desktop\\m6a\\11.cor")     #ùĿ¼

#ȡļ,ݽд
rt=read.table("m6aGeneExp.txt", header=T, sep="\t", check.names=F)
rt=as.matrix(rt)
rownames(rt)=rt[,1]
exp=rt[,2:ncol(rt)]
dimnames=list(rownames(exp),colnames(exp))
data=matrix(as.numeric(as.matrix(exp)),nrow=nrow(exp),dimnames=dimnames)
data=avereps(data)

#ɾƷ
group=sapply(strsplit(colnames(data),"\\_"), "[", 2)
data=data[,group=="treat"]

#ȡбļ
geneRT=read.table("gene.txt", header=T, sep="\t", check.names=F, row.names=1)
gene1=row.names(geneRT)[geneRT[,1]=="erasers"]      #ȡصĻ
gene2=row.names(geneRT)[geneRT[,1]=="writers"]      #ȡصĻ

#Լ
outTab=data.frame()
for(i in gene1){
	for(j in gene2){
		x=as.numeric(data[i,])
		y=as.numeric(data[j,])
		corT=cor.test(x, y, method = 'spearman')
		cor=corT$estimate
		pvalue=corT$p.value
		if((abs(cor)>corFilter) & (pvalue<pvalueFilter)){
			outTab=rbind(outTab, cbind(Gene1=i, Gene2=j, cor, pvalue))
			#ͼ
			df1=as.data.frame(cbind(x,y))
			p1=ggplot(df1, aes(x, y)) + 
				xlab(i)+ylab(j)+ 
				geom_point()+ geom_smooth(method="lm",formula = y ~ x) + theme_bw()+
				stat_cor(method = 'spearman', aes(x =x, y =y))
			p2=ggMarginal(p1, type = "density", xparams = list(fill = "orange"),yparams = list(fill = "blue"))
			#ͼ
			pdf(file=paste0(i, "_", j, ".pdf"),width=5,height=4.8)
			print(p2)
			dev.off()
		}
	}
}

#ԼĽ
write.table(file="corResult.txt",outTab,sep="\t",quote=F,row.names=F)


######Video source: https://ke.biowolf.cn
######ѧ: https://www.biowolf.cn/
######΢Źںţbiowolf_cn
######䣺biowolf@foxmail.com
######΢: 18520221056

