######Video source: https://ke.biowolf.cn
######ѧ: https://www.biowolf.cn/
######΢Źںţbiowolf_cn
######䣺biowolf@foxmail.com
######΢: 18520221056

#if (!requireNamespace("BiocManager", quietly = TRUE))
#    install.packages("BiocManager")
#BiocManager::install("limma")

#install.packages("ggpubr")
#install.packages("reshape2")


#ð
library(limma)
library(reshape2)
library(ggpubr)

expFile="6364normalize.txt"     #ļ
geneFile="gene.txt"         #бļ
m6aCluFile="m6Acluster.txt"        #m6A͵Ľļ
geneCluFile="geneCluster.txt"      #͵Ľļ
setwd("C:\\Users\\86151\\Desktop\\data\\gse6364\\31.geneDiff\\M6A")     #ùĿ¼

#ȡļݽд
rt=read.table(expFile, header=T, sep="\t", check.names=F)
rt=as.matrix(rt)
rownames(rt)=rt[,1]
exp=rt[,2:ncol(rt)]
dimnames=list(rownames(exp),colnames(exp))
data=matrix(as.numeric(as.matrix(exp)),nrow=nrow(exp),dimnames=dimnames)
data=avereps(data)
data=data[rowMeans(data)>0,]

#ȡĿı
gene=read.table(geneFile, header=F, check.names=F, sep="\t")
sameGene=intersect(as.vector(gene[,1]), rownames(data))
geneExp=t(data[sameGene,])

#ȡͽļ
m6aClu=read.table(m6aCluFile, header=T, sep="\t", check.names=F, row.names=1)
geneClu=read.table(geneCluFile, header=T, sep="\t", check.names=F, row.names=1)

#ϲ
twoCluster=cbind(m6aClu, geneClu)
sameSample=intersect(row.names(twoCluster), row.names(geneExp))
m6aCluData=cbind(geneExp[sameSample,,drop=F], twoCluster[sameSample,"m6Acluster",drop=F])
geneCluData=cbind(geneExp[sameSample,,drop=F], twoCluster[sameSample,"geneCluster",drop=F])

############m6A͵ͼ############
#תggplot2ļ
data=melt(m6aCluData, id.vars=c("m6Acluster"))
colnames(data)=c("m6Acluster", "Gene", "Expression")
#ͼ
bioCol=c("#0066FF","#FF0000","#FF9900","#6E568C","#7CC767","#223D6C","#D20A13","#FFD121","#088247","#11AA4D")
bioCol=bioCol[1:length(levels(factor(data[,"m6Acluster"])))]
p=ggboxplot(data, x="Gene", y="Expression", color="m6Acluster",
     xlab="",
     ylab="Gene expression",
     legend.title="m6Acluster",
     palette=bioCol)
p=p+rotate_x_text(50)
pdf(file="boxplot.m6aClu.pdf", width=12, height=10)                          #ͼƬļ
p+stat_compare_means(aes(group=m6Acluster),symnum.args=list(cutpoints = c(0, 0.001, 0.01, 0.05, 1), symbols = c("***", "**", "*", "")),label = "p.signif")
dev.off()

############ƻ͵ͼ############
#תggplot2ļ
data=melt(geneCluData, id.vars=c("geneCluster"))
colnames(data)=c("geneCluster", "Gene", "Expression")
#ͼ
bioCol=c("#0066FF","#FF0000","#FF9900","#6E568C","#7CC767","#223D6C","#D20A13","#FFD121","#088247","#11AA4D")
bioCol=bioCol[1:length(levels(factor(data[,"geneCluster"])))]
p=ggboxplot(data, x="Gene", y="Expression", color="geneCluster",
     xlab="",
     ylab="Gene expression",
     legend.title="geneCluster",
     palette=bioCol)
p=p+rotate_x_text(50)
pdf(file="boxplot.geneClu.pdf", width=12, height=10)                          #ͼƬļ
p+stat_compare_means(aes(group=geneCluster),symnum.args=list(cutpoints = c(0, 0.001, 0.01, 0.05, 1), symbols = c("***", "**", "*", "")),label = "p.signif")
dev.off()


######Video source: https://ke.biowolf.cn
######ѧ: https://www.biowolf.cn/
######΢Źںţbiowolf_cn
######䣺biowolf@foxmail.com
######΢: 18520221056

