######Video source: https://ke.biowolf.cn
######ѧ: https://www.biowolf.cn/
######΢Źںţbiowolf_cn
######䣺biowolf@foxmail.com
######΢: 18520221056

#if (!requireNamespace("BiocManager", quietly = TRUE))
#    install.packages("BiocManager")
#BiocManager::install("limma")

#install.packages("pheatmap")
#install.packages("reshape2")
#install.packages("ggpubr")


#ð
library(limma)
library(pheatmap)
library(reshape2)
library(ggpubr)

clusterFile="m6Acluster.txt"      #m6A͵Ľļ
setwd("C:\\Users\\86151\\Desktop\\data\\gse6364\\16.m6ACluHeatmap")      #ùĿ¼

#ȡļ
rt=read.table(clusterFile, header=T, sep="\t", check.names=F, row.names=1)
rt=rt[order(rt$m6Acluster),]

#׼ͼ
data=t(rt[,1:(ncol(rt)-1),drop=F])
Type=rt[,ncol(rt),drop=F]

#ͼע͵ɫ
bioCol=c("#0066FF","#FF0000","#FF9900","#6E568C","#7CC767","#223D6C","#D20A13","#FFD121","#088247","#11AA4D")
ann_colors=list()
m6aCluCol=bioCol[1:length(levels(factor(Type$m6Acluster)))]
names(m6aCluCol)=levels(factor(Type$m6Acluster))
ann_colors[["m6Acluster"]]=m6aCluCol

#ͼ
pdf("heatmap.pdf", width=7, height=4.5)
pheatmap(data,
         annotation=Type,
         annotation_colors = ann_colors,
         color = colorRampPalette(c(rep("blue",2), "white", rep("red",2)))(100),
         cluster_cols =F,
         cluster_rows =T,
         scale="row",
         show_colnames=F,
         show_rownames=T,
         fontsize=6,
         fontsize_row=7,
         fontsize_col=6)
dev.off()

#תggplot2ļ
data=melt(rt, id.vars=c("m6Acluster"))
colnames(data)=c("m6Acluster", "Gene", "Expression")

#ͼ
p=ggboxplot(data, x="Gene", y="Expression", color = "m6Acluster", 
	     ylab="Gene expression",
	     xlab="",
	     legend.title="m6Acluster",
	     palette = m6aCluCol,
	     width=1)
p=p+rotate_x_text(60)
p1=p+stat_compare_means(aes(group=m6Acluster),
	      symnum.args=list(cutpoints = c(0, 0.001, 0.01, 0.05, 1), symbols = c("***", "**", "*", " ")),
	      label = "p.signif")

#ͼ
pdf(file="boxplot.pdf", width=6, height=5)
print(p1)
dev.off()


######Video source: https://ke.biowolf.cn
######ѧ: https://www.biowolf.cn/
######΢Źںţbiowolf_cn
######䣺biowolf@foxmail.com
######΢: 18520221056

