######Video source: https://ke.biowolf.cn
######ѧ: https://www.biowolf.cn/
######΢Źںţbiowolf_cn
######䣺biowolf@foxmail.com
######΢: 18520221056

#if (!requireNamespace("BiocManager", quietly = TRUE))
#    install.packages("BiocManager")
#BiocManager::install("limma")

#install.packages("pheatmap")
#install.packages("reshape2")
#install.packages("ggpubr")


#ð
library(limma)
library(pheatmap)
library(reshape2)
library(ggpubr)

clusterFile="m6Acluster.txt"         #m6A͵Ľļ
ssgseaFile="ssGSEA.result.txt"       #ssGSEAĴļ
setwd("C:\\Users\\86151\\Desktop\\data\\gse6364\\19.immHeatmap")      #ùĿ¼

#ȡ͵Ľļ
cluster=read.table(clusterFile, header=T, sep="\t", check.names=F, row.names=1)
cluster=cluster[,-ncol(cluster)]

#ȡssGSEAĽļ
ssgsea=read.table(ssgseaFile, header=T, sep="\t", check.names=F, row.names=1)
ssgsea=t(ssgsea)

#
sameSample=intersect(row.names(cluster), row.names(ssgsea))
cluster=cluster[sameSample,,drop=F]
ssgsea=ssgsea[sameSample,,drop=F]

#Լ
cor=cor(ssgsea, cluster, method="spearman")

#ͼ
pdf(file="heatmap.pdf", width=7, height=4.5)
pheatmap(cor,
         color = colorRampPalette(c(rep("blue",1), "white", rep("red",1)))(100),
         cluster_cols =F,
         cluster_rows =T,
         display_numbers = T,
         show_colnames=T,
         show_rownames=T,
         angle_col =45,
         fontsize=6,
         fontsize_row=7,
         fontsize_col=6)
dev.off()


######Video source: https://ke.biowolf.cn
######ѧ: https://www.biowolf.cn/
######΢Źںţbiowolf_cn
######䣺biowolf@foxmail.com
######΢: 18520221056

